;e[ûovliiCgC_[j
; PIC12F675̃szu
;
;Pin1   Vdd   +2V to +5.5V d
;   2   GP5, T1CKI, OSC1,  CLKIN
;   3   GP4, AN3,   T1G,   OSC2, CLKOUT
;   4   GP3, MCLR,  Vpp
;   5   GP2, AN2,   T0CLI, INT,  COUT
;   6   GP1, AN1,   CIN-,  Vref, ICSPCLK
;   7   GP0, AN0,   CIN+,  ICSPDAT
;   8   Vss   0V d
;


	list      p=12f675	; |󎞂ɃXgt@C܂
	#include <p12f675.inc>	; 12F675p`t@Cǂݍ݂܂
	errorlevel  -302	; |󎞂302G[oȂ悤ɂ܂

	__CONFIG _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_OSC_NOCLKOUT

	radix	dec		; ȗ̐l\POiɂ܂B





	ORG	000H
		GOTO	INIT
	


	TABLE1		EQU	20H
	T1_0		EQU	21H
	T1_1		EQU	22H	
	T1_2		EQU	23H
	T1_ON		EQU	24H
	_PWM1		EQU	25H
	W1_0		EQU	26H  
	TABLE2		EQU	27H
	T2_0		EQU	28H
	T2_1		EQU	29H	
	T2_2		EQU	2AH
	T2_ON		EQU	2BH
	_PWM2		EQU	2CH
	W2_0		EQU	2DH  
	TABLE3		EQU	2EH
	T3_0		EQU	2FH
	T3_1		EQU	30H	
	T3_2		EQU	31H
	T3_ON		EQU	32H
	_PWM3		EQU	33H
	W3_0		EQU	34H  
	TABLE4		EQU	35H
	T4_0		EQU	36H
	T4_1		EQU	37H	
	T4_2		EQU	38H
	T4_ON		EQU	39H
	_PWM4		EQU	3AH
	W4_0		EQU	3BH  
	TABLE5		EQU	3CH
	T5_0		EQU	3DH
	T5_1		EQU	3EH	
	T5_2		EQU	3FH
	T5_ON		EQU	40H
	_PWM5		EQU	41H
	W5_0		EQU	42H  








;---- [` ----
INIT:
	BCF	STATUS,RP0			;BANK 0

	CLRF	GPIO
			
	MOVLW   B'00000111'			;Rp[^sdl
	MOVWF	CMCON                      	; 

	BSF	STATUS,RP0			;BANK 1

	MOVLW   B'00001000'			;IN 3   OUT 0,1,2,4,5
	MOVWF	TRISIO                      	; GPIO

	MOVLW   B'10000111'                  ; T0CS'0'
	MOVWF	OPTION_REG 
                       		; OPTIONWX^ɏ
	CLRF	ANSEL				;AiO͕sdl

		
	BCF	STATUS,RP0			;BANK 0
	


	CLRF	TABLE1
	CLRF	T1_0
	CLRF	T1_1
	CLRF	T1_2		
	CLRF	T1_ON
	CLRF	_PWM1		
	CLRF	W1_0
	CLRF	TABLE2
	CLRF	T2_0
	CLRF	T2_1
	CLRF	T2_2		
	CLRF	T2_ON
	CLRF	_PWM2		
	CLRF	W2_0
	CLRF	TABLE3
	CLRF	T3_0
	CLRF	T3_1
	CLRF	T3_2		
	CLRF	T3_ON
	CLRF	_PWM3		
	CLRF	W3_0
	CLRF	TABLE4
	CLRF	T4_0
	CLRF	T4_1
	CLRF	T4_2		
	CLRF	T4_ON
	CLRF	_PWM4		
	CLRF	W4_0
	CLRF	TABLE5
	CLRF	T5_0
	CLRF	T5_1
	CLRF	T5_2		
	CLRF	T5_ON
	CLRF	_PWM5	
	CLRF	W5_0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN1
	CALL	TABLE_PTN1
	MOVWF	TABLE1 	
	INCF	_PWM1,F
	MOVLW	D'28'		;<<<<<<<<
	SUBWF	_PWM1,W
	BTFSC	STATUS,C
	CLRF	_PWM1
	BSF	W1_0,F

MAIN2
	CALL	TABLE_PTN2
	MOVWF	TABLE2
	INCF	_PWM2,F
	MOVLW	D'28'		;<<<<<<<<
	SUBWF	_PWM2,W
	BTFSC	STATUS,C
	CLRF	_PWM2
	BSF	W2_0,F
	
MAIN3
	CALL	TABLE_PTN3
	MOVWF	TABLE3
	INCF	_PWM3,F
	MOVLW	D'28'		;<<<<<<<<
	SUBWF	_PWM3,W
	BTFSC	STATUS,C
	CLRF	_PWM3
	BSF	W3_0,F

MAIN4
	CALL	TABLE_PTN4
	MOVWF	TABLE4
	INCF	_PWM4,F
	MOVLW	D'28'		;<<<<<<<<
	SUBWF	_PWM4,W
	BTFSC	STATUS,C
	CLRF	_PWM4
	BSF	W4_0,F
	
MAIN5
	CALL	TABLE_PTN5
	MOVWF	TABLE5
	INCF	_PWM5,F
	MOVLW	D'28'		;<<<<<<<<
	SUBWF	_PWM5,W
	BTFSC	STATUS,C
	CLRF	_PWM5
	BSF	W5_0,F
MAIN1_1	
	GOTO	TM1_2
MAIN1_2
	GOTO	MAIN1



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TM1_0
	MOVLW	D'250'
	MOVWF	T1_0

	MOVLW	D'250'
	MOVWF	T2_0

	MOVLW	D'250'
	MOVWF	T3_0

	MOVLW	D'250'
	MOVWF	T4_0

	MOVLW	D'250'
	MOVWF	T5_0

	MOVF	TABLE1,W
	MOVWF	T1_ON

	MOVF	TABLE2,W
	MOVWF	T2_ON

	MOVF	TABLE3,W
	MOVWF	T3_ON

	MOVF	TABLE4,W
	MOVWF	T4_ON

	MOVF	TABLE5,W
	MOVWF	T5_ON

T1_0LP
	CALL	T1_01LP		;1Ԗڂ
	CALL	T2_01LP		;2Ԗڂ
	CALL	T3_01LP		;3Ԗڂ
	CALL	T4_01LP		;4Ԗڂ
	CALL	T5_01LP		;5Ԗڂ
	GOTO	T1_0LP		;1Ԗڂ֖߂
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

T1_01LP
	DECFSZ	T1_0,F		;D'250'
	GOTO	_PWM1_1		;250 
	BSF	W1_0,F		;250B	o͎wON 
	BSF	W2_0,F		;250B	o͎wON 
	BSF	W3_0,F		;250B	o͎wON 
	BSF	W4_0,F		;250B	o͎wON 
	BSF	W5_0,F		;250B	o͎wON 
	GOTO	T1_10LP		;1
_PWM1_1				;250 
	BTFSS	W1_0,F		;o͎wߔr 
	RETURN			;o͎wOFF			߂
	DECFSZ	T1_ON,F		;TABLE1		o͎wON 
	GOTO	_PWM1_2		;TABLE񐔖
	BCF	GPIO,0		;oOFF	TABLE񐔓B
	BCF	W1_0,F		;o͎wOFF 
	RETURN			;߂
_PWM1_2	
	BSF	GPIO,0		;oON
	RETURN			;߂

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

T2_01LP
	DECFSZ	T2_0,F		;D'250'
	GOTO	_PWM2_1		;250 
	BSF	W1_0,F		;250B	o͎wON 
	BSF	W2_0,F		;250B	o͎wON 
	BSF	W3_0,F		;250B	o͎wON 
	BSF	W4_0,F		;250B	o͎wON 
	BSF	W5_0,F		;250B	o͎wON 
	GOTO	T1_10LP		;1
_PWM2_1				;250 
	BTFSS	W2_0,F		;o͎wߔr 
	RETURN			;o͎wOFF			߂
	DECFSZ	T2_ON,F		;TABLE2
	GOTO	_PWM2_2		;TABLE񐔖
	BCF	GPIO,1		;oOFF	TABLE񐔓B
	BCF	W2_0,F		;o͎wOFF 
	RETURN			;߂	
_PWM2_2
	BSF	GPIO,1		;oON
	RETURN			;߂

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

T3_01LP
	DECFSZ	T3_0,F		;D'250'
	GOTO	_PWM3_1		;250 
	BSF	W1_0,F		;250B	o͎wON 
	BSF	W2_0,F		;250B	o͎wON 
	BSF	W3_0,F		;250B	o͎wON 
	BSF	W4_0,F		;250B	o͎wON 
	BSF	W5_0,F		;250B	o͎wON 
	GOTO	T1_10LP		;1
_PWM3_1				;250 
	BTFSS	W3_0,F		;o͎wߔr 
	RETURN			;o͎wOFF			߂
	DECFSZ	T3_ON,F		;TABLE3
	GOTO	_PWM3_2		;TABLE񐔖
	BCF	GPIO,2		;oOFF	TABLE񐔓B
	BCF	W3_0,F		;o͎wOFF 
	RETURN			;߂
_PWM3_2
	BSF	GPIO,2		;oON
	RETURN			;߂


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

T4_01LP
	DECFSZ	T4_0,F		;D'250'
	GOTO	_PWM4_1		;250 
	BSF	W1_0,F		;250B	o͎wON 
	BSF	W2_0,F		;250B	o͎wON 
	BSF	W3_0,F		;250B	o͎wON 
	BSF	W4_0,F		;250B	o͎wON 
	BSF	W5_0,F		;250B	o͎wON 
	GOTO	T1_10LP		;1
_PWM4_1				;250 
	BTFSS	W4_0,F		;o͎wߔr 
	RETURN			;o͎wOFF			߂
	DECFSZ	T4_ON,F		;TABLE4
	GOTO	_PWM4_2		;TABLE񐔖
	BCF	GPIO,4		;oOFF	TABLE񐔓B
	BCF	W4_0,F		;o͎wOFF 
	RETURN			;߂	
_PWM4_2
	BSF	GPIO,4		;oON
	RETURN			;߂

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

T5_01LP
	DECFSZ	T5_0,F		;D'250'
	GOTO	_PWM5_1		;250 
	BSF	W1_0,F		;250B	o͎wON 
	BSF	W2_0,F		;250B	o͎wON 
	BSF	W3_0,F		;250B	o͎wON 
	BSF	W4_0,F		;250B	o͎wON 
	BSF	W5_0,F		;250B	o͎wON 
	GOTO	T1_10LP		;1
_PWM5_1				;250 
	BTFSS	W5_0,F		;o͎wߔr 
	RETURN			;o͎wOFF			߂
	DECFSZ	T5_ON,F		;TABLE5
	GOTO	_PWM5_2		;TABLE񐔖
	BCF	GPIO,5		;oOFF	TABLE񐔓B
	BCF	W5_0,F		;o͎wOFF 
	RETURN			;߂
_PWM5_2
	BSF	GPIO,5		;oON
	RETURN			;߂





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TM1_1				;1
	MOVLW	D'6'		;D'250'Xs[h
	MOVWF	T1_1
T1_1LP	
 	GOTO	TM1_0
T1_10LP
	DECFSZ	T1_1,F		;D'250' (1)
	GOTO	T1_1LP		;250(1)
	GOTO	T1_20LP		;250B(1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TM1_2				;2
	MOVLW	D'1'
	MOVWF	T1_2
T1_2LP
	GOTO	TM1_1
T1_20LP
	DECFSZ	T1_2,F		;D'1' (2)
	GOTO	T1_2LP		;1(2)
	GOTO	MAIN1_2		;1B(2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	ORG	100H
TABLE_PTN1
	movlw	H'01'
	movwf	PCLATH	; e[u 0x100`0x1FFԒnɑ
	
	andlw	B'11111111'	; _DATA ̉ 3bit݂̂Q

	MOVF	_PWM1,W
	ADDWF	PCL,F

	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'	
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	140H	
TABLE_PTN2
	movlw	H'01'
	movwf	PCLATH	; e[u 0x100`0x1FFԒnɑ
	
	andlw	B'11111111'	; _DATA ̉ 3bit݂̂Q

	MOVF	_PWM2,W
	ADDWF	PCL,F

	RETLW	D'1'	
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	ORG	180H
TABLE_PTN3
	movlw	H'01'
	movwf	PCLATH	; e[u 0x100`0x1FFԒnɑ
	
	andlw	B'11111111'


	MOVF	_PWM3,W
	ADDWF	PCL,F

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	ORG	1C0H
TABLE_PTN4
	movlw	H'01'
	movwf	PCLATH	; e[u 0x100`0x1FFԒnɑ
	
	andlw	B'11111111'	; _DATA ̉ 3bit݂̂Q

	MOVF	_PWM1,W
	ADDWF	PCL,F

	RETLW	D'1'

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	
	RETLW	D'1'	
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	ORG	200H
TABLE_PTN5
	movlw	H'02'
	movwf	PCLATH	; e[u 0x100`0x1FFԒnɑ
	
	andlw	B'11111111'	; _DATA ̉ 3bit݂̂Q

	MOVF	_PWM1,W
	ADDWF	PCL,F

	RETLW	D'1'

	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'	
	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'

	RETLW	D'250'
	RETLW	D'25'
	RETLW	D'10'
	RETLW	D'5'
	RETLW	D'2'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'
	RETLW	D'1'


END






	